/*
 * iomodes.c 9.2 92/07/01 12:31:06
 * Copyright 1991 Intel Corporation, Inc.
 * See Copyright for complete rights and liability information.
 */

#include <fcntl.h>
#include <stdio.h>
#include <cube.h>

main()
{
	int           i, fd;
	unsigned long start, now;
	unsigned long loop_start, loop_cur;
	long          mode, iam;
	char          instring[40], msg[40];

	iam = mynode();

	if(iam == 0) {
		printf("Enter I/O mode (0, 1, 2, or 3):\n");
		gets(instring);
		sscanf(instring, "%ld", &mode);
		fd = open("mydat", O_WRONLY | O_CREAT | O_TRUNC, 
		          0666);
		if(fd == -1) {
			perror("/cfs/mydat");
			killcube(-1, -1);
		}
		csend(1, (char *)&mode, sizeof(mode), -1, 0);
	} else {
		crecv(1, (char *)&mode, sizeof(mode));
		fd = open("mydat", O_WRONLY, 0666);
	}

	setiomode(fd, mode);
	printf("Node %d using mode %d\n", iam, iomode(fd));

	start = mclock();

	for(i=0;i<25;i++) {
		if(iam==0) {
			loop_start = mclock();
			loop_cur = loop_start;
			while(loop_cur - loop_start < 1000) {
				loop_cur = mclock();
			}
		}
		now = mclock() - start;
		sprintf(msg, "%5lu %s %2ld\n", now, "Hello from node ", iam);
		cwrite(fd, msg, strlen(msg));
	}

	printf("Node %d done writing\n", iam);
	close(fd);
	printf("Node %d finished\n", iam);
}
