#include <stdio.h>
#include <math.h>

main(argc,argv)
int argc;
char **argv;
{
    int  i,j,k;
    int  Arows,Brows,Bcols;
    FILE  *fd,*fopen();

    if (argc < 5) {
      printf("Usage matmult_gen Arows Brows Bcols fileA fileB\n");
      exit(0);
    }
    sscanf(argv[1],"%d",&Arows);
    sscanf(argv[2],"%d",&Brows);
    sscanf(argv[3],"%d",&Bcols);
    
    fd = fopen(argv[4],"w");
    for (j=0; j<Arows; j++) {
       for (i=0; i<Brows; i++) {
          fprintf(fd,"%f  ", (float) i);
       }
       fprintf(fd,"\n");
    }
    fclose(fd);
    fd = fopen(argv[5],"w");
    for (j=0; j<Bcols; j++) {
       for (i=0; i<Brows; i++) {
          fprintf(fd,"%f  ", 1.0);
       }
       fprintf(fd,"\n");
    }
 }
 


float **create_matrix(row,col)
int row,col;
{
  float *p,**q;
  int i,j,k;

  k = row*col*sizeof(float);
  p = (float *) malloc(k);
  if (p == NULL) {
    printf("can't allocate memory\n");
    exit(1);
  }
  q = (float **) calloc(row,sizeof(float *));
  if (q == NULL) {
    printf("can't allocate memory\n");
    exit(1);
  }
  for (i=0; i<row; i++)
    q[i] = p + i*col;
  return(q);
}
