#include <mpl.h>          /* include files */
#include <stdio.h>
#include <sys/time.h>

double when(){		/* function to record current time*/
 struct timeval tp;
 struct timezone tzp;
 gettimeofday(&tp,&tzp);
 return ((double) tp.tv_sec + (double) tp.tv_usec*1e-6);
}
/*****************************************--*/


/*****************************************--*/
sum_local(int n,plural double * plural sum){  
 plural int i,stop;
 int pnt;
 double n2,fourn;

 pnt= (int) n/ nproc;
 if (pnt==0) pnt=1;
 fourn=4.0*n;
 n2= (double)n* (double)n;

 *sum=0;
 if ( iproc < n )
 	for ( i=iproc*pnt+1,stop=i+pnt; i <stop;i++)
        	*sum+= fourn/( n2+(i+0.5)*(i+0.5));
 return;
}
/*****************************************--*/
double reduction(plural double * plural sum){
 int i;

 for (i=1; i< nxproc; i*=2)    /*rows*/
      *sum += xnetE[i].*sum;
 for (i=1; i< nyproc; i*=2)    /*columns*/
      *sum += xnetS[i].*sum;

 return proc[0].*sum;
}
/*****************************************--*/
main(){
 int n;
 plural double sum;
 double time,timecom,comtime,timesum;
 double pi;

 printf("Enter n in the summation formula :");
 scanf("%d/n", &n);

 time = when();
 sum_local(n,&sum);
timesum=when();
 pi=reduction(&sum);
 timecom = when();
time=timecom-time;
comtime=timecom-timesum; 
 printf ("PI number is approximately calculated as %1.10lf in time %1.10lf. \n",pi,time);
printf(" The time to for collecting all local sums = %1.10f \n",comtime);
}


