

CPS616 term Project Proposal
Implementation of Voronoi Diagrams using Web Technologies.

1) What is Voronoi Diagrams

      Formal Definition: The set of all points closer to a given point in a point set than to all other points in the set is a geometric structure  called Voronoi Polygon of the point. The union of  all the Voronoi polygons for a point set is called as Voronoi diagram of the set.

     The Voronoi diagrams are  the natural structure for closest point problems.
     Example: The following problem gives better understanding of the Voronoi Diagrams.

     Given the locations of the post-offices in a city. Finding the optimal delivery regions of each post office is simply constructing a voronoi diagram. For every house in the city we assign the closest post office to deal with.

2) Applications of the Voronoi Diagrams

     * Finding the nearest neighbor of each query point in a point set. This can be applied to any delivery service in the daily life; post offices, pizza-delivery, emergency services, police control etc.
     * Generating a convex hull from the Voronoi diagram of a set. Convex hulls has many theoretical and practical applications, e.g., pattern recognition, elimination of boundary data, point location, statistics, etc. 
     * Finding euclidian Minimum Spanning Tree, (MST)
     * Solving travelling salesman problem in a reasonable time.
     * Triangulation of a given point set. 

     (The last tree applications are very useful needless to say.)

3) Implementation

    I am planning to find Voronoi diagrams by using web technologies. This application mostly requires java programming.
    I may use some VRML and Javascript while writing a report to explain algoritm, which i am planning to use.
    Program may take inputs, i.e, point set, either by a mouse or can load it from the database , for example, a city map, or a state map.

    Running of the program:
      I am planning to use to display the steps of the algorithm during the running of program as possible as JAVA AWT packet allows to display geometrical shapes. In that case, program will use a sweeping line to sweep the map. Whenever it sweeps over the cities, the voronoi polygons will be appearing on the screen.
